//          File: graphtest.cpp
//        Author: Elena Machkasova
// Last Modified: April 25, 2001
//         Topic: Linked List Implementation of Graphs in C++

// The file contains a test program for the class Graph

#include <iostream>
#include "graph.h"
#include "disjointSet.h"
 
using namespace std;

int main() {
  
  Graph myGraph;
  
  //code showing how to use the graph class (same as in lab4)
  myGraph.AddVertex(1);
  myGraph.AddVertex(2);
  myGraph.AddVertex(3);
  myGraph.AddVertex(4);
  
  myGraph.AddEdge(1, 2, 1);
  myGraph.AddEdge(2, 1, 1);
  myGraph.AddEdge(2, 3, 2);
  myGraph.AddEdge(4, 3, 3);
  myGraph.AddEdge(1, 3, 4);
  myGraph.AddEdge(2, 4, 2);

  myGraph.print();
  
  //code showing how disjoint set can be used
  DisjointSet set1(1);
  DisjointSet set2(2);
  DisjointSet set3(3);
  DisjointSet set4(4);
  DisjointSet set5(5);
  DisjointSet set6(6);
  DisjointSet set7(7);

  set1.unifyWith(&set2);
  set3.unifyWith(&set4);
  set5.unifyWith(&set6);
  set5.unifyWith(&set7);
  set1.unifyWith(&set4);

  cout << "performing find operations." << endl;
  cout << set1.find()->elementNum << "\n";
  cout << set2.find()->elementNum << "\n";
  cout << set3.find()->elementNum << "\n";
  cout << set4.find()->elementNum << "\n";
  cout << set5.find()->elementNum << "\n";
  cout << set6.find()->elementNum << "\n";
  cout << set7.find()->elementNum << "\n";

  return 0;
}
